<script setup lang="ts">
    import { computed, ref, watch } from "vue";
    import DisplayRecording from "./DisplayRecording.vue";
    import { Coordinate } from "ol/coordinate";
    import { LineDataExport, PhotoMetaExport } from "../functions/types";
    import { wayPoints } from "../functions/paths";
    import { getBackendURL } from "../functions/backend";
    import toastr from "toastr";
    import { useRoute } from "vue-router";

    const route = useRoute();
    const slug = computed(() => {
        return (route.params?.slug as string) ?? "";
    });
    watch(slug, () => {
        location.reload();
    });

    let password = ref("");
    const showRoutes = ref(true);

    let debounce = setTimeout(() => {}, 0);
    function callDebouncedRefresh() {
        clearTimeout(debounce);
        debounce = setTimeout(getDataFromServer, 400);
    }
    watch(password, () => {
        callDebouncedRefresh();
    });

    function getDataFromServer() {
        fetch(
            getBackendURL(
                "get-view-data?secret=" + encodeURIComponent(password.value) + "&slug=" + encodeURIComponent(slug.value)
            ),
            {
                method: "GET",
            }
        )
            .then(async function (response) {
                if (response.ok) {
                    toastr.success("Zugriff gewährt");
                    requestData.value = await response.json();
                } else {
                    toastr.error("Falsches Passwort oder anderer Fehler");
                }
            })
            .catch((error) => {
                console.error("Could not load management-JSON", error);
                toastr.error("Unbekannter Fehler");
            });
    }

    type GroupData = {
        quest_id: number;
        name: string;
        points: LineDataExport;
        photos: PhotoMetaExport;
    };

    type RequestData = {
        name: string;
        groups: GroupData[];
    };

    const requestData = ref({
        name: ": Passwort Eingeben",
        groups: [],
    } as RequestData);

    const groupSelectorValues = computed(() => {
        return [
            { value: -1, label: "Bitte Wählen" },
            ...requestData.value.groups.map((grp, index) => {
                return {
                    value: index,
                    label: grp.name,
                };
            }),
        ];
    });

    const groupSelection = ref(-1);

    const groupData = computed((): GroupData | null => {
        if (groupSelection.value == -1) {
            return null;
        }

        return requestData.value.groups[groupSelection.value];
    });

    const dataPointsHolder = computed((): LineDataExport => {
        if (groupData.value == null) {
            return [];
        } else {
            return groupData.value.points;
        }
    });
    const photosMetaHolder = computed((): PhotoMetaExport => {
        if (groupData.value == null) {
            return [];
        } else {
            return groupData.value.photos;
        }
    });
    const wayPointsArrHolder = computed((): { key: string; coords: Coordinate[][] }[] => {
        return Object.keys(wayPoints)
            .filter((key) => {
                if (!showRoutes.value) {
                    return false;
                }

                if (groupData.value == null) {
                    return false;
                }

                return groupData.value.quest_id == parseInt(key);
            })
            .map((key) => {
                return {
                    key: key,
                    coords: wayPoints[parseInt(key)],
                };
            });
    });
</script>

<template>
    <div class="container">
        <h1><router-link to="/">Wandertag App</router-link> - Aufnahmen {{ requestData.name }}</h1>

        <v-row class="justify-center mx-4 my-0">
            <v-text-field class="v-col-10" type="password" v-model="password" density="compact" label="Passwort:" />
            <VCheckbox class="v-col-6 v-col-md-4" v-model="showRoutes" density="compact" label="Routen anzeigen" />

            <v-autocomplete
                v-if="requestData.name != ': Passwort Eingeben'"
                class="v-col-12 mt-0"
                v-model="groupSelection"
                label="Gruppe/Route auswählen"
                :items="groupSelectorValues"
                density="compact"
                item-title="label"
                item-value="value"
                :auto-select-first="true"
            ></v-autocomplete>
        </v-row>

        <v-row class="mx-2">
            <DisplayRecording
                :password="password"
                :data-points="dataPointsHolder"
                :photos-meta="photosMetaHolder"
                :way-points-arr="wayPointsArrHolder"
            ></DisplayRecording>
        </v-row>
    </div>
</template>

<style scoped></style>
